/*  gmpeg- MPEG-1 player for Linux
 *
 *  Copyright (C) 2000 Jayan. S. R
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "gmpeg.h"


char *file_name;

void delete_event_handler ( GtkWidget *widget, 
										GdkEvent *event,
                    gpointer data )
{
	gtk_main_quit();
}

void ok_dialog_clicked ( GtkWidget *widget,
                         GtkDialog *dlg )
{
	gtk_widget_destroy ( GTK_WIDGET (dlg) );
}

void play_callback ( GtkWidget *widget,
										 gpointer data )
{
	
	if ( sdl_initialize() < 0 ) {
	  exit (1);
	}
	g_print ( "sdl initialized starting to play...\n" ) ;

	g_print ( "filename :%s\n", (char *)data );
	if ( file_name != NULL ){
		resume_mpeg ();
	}
	else 
	{
  dialog_box_error ( "Invalid file name,\n please open a mpeg file!", 
	                   "Okay " );
	}
}

void pause_callback ( GtkWidget *widget,
								      GdkEvent *event,
											gpointer data )
{
	pause_mpeg ( );

}

void stop_callback ( GtkWidget *widget,
								     GdkEvent *event,
										 gpointer data )
{
	stop_mpeg();

}



void loop_check_callback ( GtkWidget *widget,
													 gpointer data )
{
	if ( GTK_TOGGLE_BUTTON ( widget)->active )
	{
	  loop_active = 1;
		loop_mpeg ( );
		g_print ( "active \n");
	}
	else 
	{
		loop_active = 0;
		loop_mpeg ( );
		g_print ( "inactive \n" );
	}
  g_print (" loop \n");
}

void zoom_check_callback ( GtkWidget *widget,
													 gpointer data )
{
  if ( GTK_TOGGLE_BUTTON ( widget )->active )
	{
		zoom_active = 1;
		zoom_mpeg ( );
		g_print ( "zoom active\n" );
	}
	else 
	{
		zoom_active = 0;
		zoom_mpeg ( );
		g_print ( "zoom inactive\n" );
	}
}

void file_ok_clicked_callback ( GtkWidget *widget,
                                GtkFileSelection *fs )
{
	file_name = gtk_file_selection_get_filename ( GTK_FILE_SELECTION (fs));
  g_print ( "file selected : %s\n", file_name );
	play_mpeg ( file_name );
	gtk_widget_destroy( GTK_WIDGET (fs) );
}

void file_open_callback ( GtkWidget *widget,
                          GdkEvent *event,
													gpointer data )
{
	GtkWidget *file_sel;

	file_sel = gtk_file_selection_new ( "Open" );
	/*gtk_file_selection_complete( file_sel, "*.mpeg" ); /* check warning */

  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                                            (file_sel)->cancel_button),
			       "clicked", (GtkSignalFunc) gtk_widget_destroy,
			       GTK_OBJECT (file_sel));

	gtk_signal_connect ( GTK_OBJECT (GTK_FILE_SELECTION
	                                   (file_sel)->ok_button),
							"clicked", (GtkSignalFunc) file_ok_clicked_callback, file_sel );

	gtk_widget_show ( file_sel );
	g_print ("open got focus ...\n");

}


void volume_changed_callback ( GtkAdjustment *adj)
{
	int vol;
	vol = adj->value;
	set_volume_mpeg( vol  );
}

void time_lapsed_callback ( GtkAdjustment *adj )
{
	int position = adj->value;
	/*move_frames_mpeg ( position, adj );  removed because of conflict */
	/*dialog_box_error ( " Not yet Implemented    \nAny Takers!!\n", "Okay" );*/
}

void move_slider_callback ( GtkWidget *widget )
{
	double position;
	double total;
	int slider_value;
	position = get_position_of_mpeg();
	total = get_total_size_of_mpeg();
  slider_value = (position/total)*100;

	gtk_adjustment_set_value ( GTK_ADJUSTMENT ( widget ) , slider_value );
	//gtk_scale_set_value_pos ( GTK_SCALE ( widget ), slider_value );

}


GtkWidget *xpm_label_box ( GtkWidget *parent,
									         gchar **xpm_data,
													 gchar *label_text )
{
  GtkWidget *box;
	GtkWidget *label;
	GtkWidget *pixmapwid;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkStyle *style;

	box = gtk_hbox_new ( FALSE, 0 );
	gtk_container_set_border_width ( GTK_CONTAINER (box ), 2 );

	style = gtk_widget_get_style ( parent );

	pixmap = gdk_pixmap_create_from_xpm_d ( parent->window,
	                                      &mask, &style->bg[GTK_STATE_NORMAL],
																				xpm_data );
	
	pixmapwid = gtk_pixmap_new ( pixmap, mask );

  gtk_box_pack_start ( GTK_BOX (box ), pixmapwid, FALSE, FALSE, 3 );

	gtk_widget_show ( pixmapwid );

	if ( label_text != NULL ) {
	  label = gtk_label_new ( label_text );
	  gtk_box_pack_start ( GTK_BOX (box ), label, FALSE, FALSE, 3 );
	  gtk_widget_show ( label );
	}
	
	
	return box;
}

void full_screen_callback ( GtkWidget *widget )
{
	g_print ( "full screen\n" );
	full_screen_mpeg ();
}


void about_callback ( GtkWidget *widget )
{
	dialog_box_error ( "    gmpeg 0.1 \n   Copyright (c)2000 Jayan S R.  <jayansr@users.sourceforge.net>\n\nThis program is free software, you can redistribute it\nand/or modify it under the terms of the GNU Gneral Public\nLicense as published by the Free Software Foundation; either\nver 2 of the License or ( at your option ) any later version.\n\n The Program is distributed in hopes that it will be useful\nbut WITHOUT ANY WARRANTY; without even the implied\nwarranty of MERCHANTABILITY of FITNESS FOR A\nPARTICULAR PURPOSE. See the GNU General Public\nLicense for more details.\n\nYou should have received a copy of the GNU General\nPublic License along with this program. If not, write\nto the Free Software Foundation, Inc, 675 Mass Ave,\n Cambridge, MA 02139, USA\n", "OK" ); g_print ( "Main Programmer: Jayan S\n" );
}

int emit_signal_slider( gpointer gp )
{
	/* attach code here to reposition the position slider */
	gtk_signal_emit_by_name( GTK_OBJECT( gp ), "changed" );

}

int main ( argc, argv )
int argc;
char **argv;
{
	GtkWidget *window;
	GtkWidget *play_button, *pause_button, *stop_button, *eject_button, 
	          *full_screen_button;
	GtkWidget *button_box_play, *button_box_pause, *button_box_stop,
	          *button_box_full_screen;
	GtkWidget *button_box_eject;
	/* controls_box -> box for the play/pause/stop buttons */
	/* controls_box2 -> box for the layout of the buttons/slider (vertical-box)*/
	GtkWidget *controls_box, *controls_box2, *controls_box3, *controls_box4;
	GtkWidget *loop_check, *zoom_check;
	GtkWidget *loop_zoom_box;
	GtkWidget *separator, *separator2;
	GtkWidget *volume_label;
	GtkObject *time_lapsed_adj, *volume_adj;
	GtkWidget *time_lapsed_scale, *volume_scale;
	GtkWidget *menu_bar, *file_menu, *help_menu;
	GtkWidget *open_item, *quit_item, *file_item, *about_item, *help_item;
	
	
	gtk_init ( &argc, &argv );
	window = gtk_window_new( GTK_WINDOW_TOPLEVEL );

	gtk_signal_connect ( GTK_OBJECT (window), "delete_event",
	                      GTK_SIGNAL_FUNC ( delete_event_handler ), NULL );

	gtk_window_set_title ( GTK_WINDOW ( window ), "Gmpeg");
	gtk_container_set_border_width ( GTK_CONTAINER ( window ), 10 );
	gtk_widget_realize ( window );


	menu_bar = gtk_menu_bar_new ( );

	file_menu = gtk_menu_new ( );
	help_menu = gtk_menu_new ();
	
	play_button  = gtk_button_new( );
  gtk_signal_connect ( GTK_OBJECT (play_button ), "clicked",
	                     GTK_SIGNAL_FUNC (play_callback), (gpointer ) file_name );
	gtk_widget_show ( play_button  );

	open_item = gtk_menu_item_new_with_label ( "Open" );
	quit_item = gtk_menu_item_new_with_label ( "Quit" );
	about_item = gtk_menu_item_new_with_label ( "About" );

	gtk_menu_append ( GTK_MENU (file_menu), open_item );
	gtk_menu_append ( GTK_MENU (file_menu), quit_item );

	gtk_menu_append ( GTK_MENU (help_menu), about_item );

	/*attach callbacks to activate signal */

	gtk_signal_connect ( GTK_OBJECT ( open_item ), "activate",
	                     GTK_SIGNAL_FUNC ( file_open_callback), NULL );

	gtk_signal_connect ( GTK_OBJECT ( quit_item ), "activate",
	                     GTK_SIGNAL_FUNC ( delete_event_handler ), NULL );

	gtk_signal_connect ( GTK_OBJECT ( about_item ), "activate",
	                     GTK_SIGNAL_FUNC ( about_callback ), NULL );
  
	file_item = gtk_menu_item_new_with_label ("File ");
	help_item = gtk_menu_item_new_with_label ("Help ");

	gtk_menu_item_right_justify ( GTK_MENU_ITEM (help_item) );
	
	gtk_widget_show ( file_item );
	gtk_widget_show ( open_item );
	gtk_widget_show ( quit_item );
	gtk_widget_show ( help_item );
	gtk_widget_show ( about_item );

	gtk_menu_item_set_submenu ( GTK_MENU_ITEM ( file_item ), file_menu );
	gtk_menu_item_set_submenu ( GTK_MENU_ITEM (help_item ), help_menu );
	gtk_menu_bar_append ( GTK_MENU_BAR ( menu_bar ), file_item );
	gtk_menu_bar_append ( GTK_MENU_BAR ( menu_bar ), help_item );

	pause_button = gtk_button_new( );
	gtk_signal_connect ( GTK_OBJECT ( pause_button  ), "clicked",
									     GTK_SIGNAL_FUNC ( pause_callback ), NULL );
	gtk_widget_show ( pause_button );

	stop_button = gtk_button_new( );
	gtk_signal_connect ( GTK_OBJECT ( stop_button ), "clicked",
									     GTK_SIGNAL_FUNC ( stop_callback ), NULL );
	gtk_widget_show ( stop_button );

	eject_button = gtk_button_new( );
	gtk_signal_connect ( GTK_OBJECT ( eject_button ), "clicked",
									     GTK_SIGNAL_FUNC ( file_open_callback ), NULL );
	gtk_widget_show ( eject_button );

	loop_check = gtk_check_button_new_with_label ( "loop" ); 
	gtk_signal_connect ( GTK_OBJECT (loop_check ), "toggled",
									     GTK_SIGNAL_FUNC ( loop_check_callback), NULL );
	gtk_widget_show ( loop_check);

	zoom_check = gtk_check_button_new_with_label ( "zoom" );
	gtk_signal_connect ( GTK_OBJECT ( zoom_check ), "toggled",
									     GTK_SIGNAL_FUNC( zoom_check_callback ), NULL );
	gtk_widget_show ( zoom_check);

	full_screen_button = gtk_button_new ( );
	gtk_signal_connect ( GTK_OBJECT ( full_screen_button ), "clicked",
	                     GTK_SIGNAL_FUNC ( full_screen_callback ), NULL );
	gtk_widget_show( full_screen_button );

	button_box_full_screen = xpm_label_box ( window, (gchar **)full_screen_data,
	                                         "full screen" );
	gtk_container_add ( GTK_CONTAINER ( full_screen_button ), 
	                    button_box_full_screen );
	gtk_widget_show ( button_box_full_screen );
	
	button_box_play  = xpm_label_box ( window, (gchar **)play_data, "play");
	gtk_container_add( GTK_CONTAINER( play_button  ), button_box_play  );
	gtk_widget_show ( button_box_play  );

	button_box_pause = xpm_label_box ( window, (gchar **)pause_data, "pause");
	gtk_container_add( GTK_CONTAINER ( pause_button ), button_box_pause );
	gtk_widget_show ( button_box_pause  );

	button_box_stop = xpm_label_box ( window, (gchar **)stop_data, "stop");
	gtk_container_add ( GTK_CONTAINER ( stop_button ), button_box_stop );
	gtk_widget_show ( button_box_stop );

	button_box_eject = xpm_label_box ( window, (gchar **)eject_data, "open");
	gtk_container_add ( GTK_CONTAINER ( eject_button ), button_box_eject );
	gtk_widget_show ( button_box_eject  );


	/* slider */

	time_lapsed_adj = gtk_adjustment_new ( 0.0, 0.0, 101.0, 0.1, 1.0, 1.0 );

	time_lapsed_scale = gtk_hscale_new ( GTK_ADJUSTMENT (time_lapsed_adj ));
	gtk_widget_show ( time_lapsed_scale );

	volume_adj = gtk_adjustment_new ( 0.0, 0.0, 101.0, 0.1, 1.0, 1.0 );
	volume_scale = gtk_hscale_new ( GTK_ADJUSTMENT ( volume_adj ));
	gtk_widget_show ( volume_scale );

	gtk_signal_connect ( GTK_OBJECT ( volume_adj ), "value_changed",
	                     GTK_SIGNAL_FUNC ( volume_changed_callback ),
											 NULL );
	/* set volume to half the scale */
	gtk_adjustment_set_value ( GTK_ADJUSTMENT (volume_adj), 50);

	volume_label = gtk_label_new ( "volume     " );
	gtk_widget_show ( volume_label );
	gtk_label_set_justify( GTK_LABEL (volume_label ), GTK_JUSTIFY_RIGHT );

	gtk_signal_connect ( GTK_OBJECT ( time_lapsed_adj ), "value_changed",
	                     GTK_SIGNAL_FUNC ( time_lapsed_callback ),
											 NULL );
	gtk_signal_connect ( GTK_OBJECT ( time_lapsed_adj ), "changed",
									     GTK_SIGNAL_FUNC ( move_slider_callback ),
											 time_lapsed_adj);   // coding here

  controls_box = gtk_hbox_new ( FALSE, 0 );
	gtk_widget_show ( controls_box );
	separator = gtk_hseparator_new ( );
	gtk_widget_show ( separator );
	separator2 = gtk_hseparator_new ( );
	gtk_widget_show ( separator2 );
	loop_zoom_box = gtk_hbox_new ( FALSE, 0 );
	gtk_widget_show ( loop_zoom_box );
	controls_box2 = gtk_vbox_new ( FALSE, 0 );
	gtk_widget_show ( controls_box2);
	controls_box3 = gtk_hbox_new ( FALSE, 0 );
	gtk_widget_show ( controls_box3 );
	controls_box4 = gtk_hbox_new ( FALSE, 0 );
	gtk_widget_show ( controls_box4 );

  gtk_box_pack_start ( GTK_BOX (loop_zoom_box), loop_check, TRUE, TRUE, 3 );
  gtk_box_pack_start ( GTK_BOX (loop_zoom_box), zoom_check, TRUE, TRUE, 3 );
	gtk_box_pack_start ( GTK_BOX (loop_zoom_box), full_screen_button, TRUE, TRUE, 3);
	gtk_box_pack_start ( GTK_BOX (controls_box3), time_lapsed_scale, TRUE,
									     TRUE, 3 );
	gtk_box_pack_start ( GTK_BOX (controls_box4), volume_label, FALSE, FALSE, 0 );
	gtk_box_pack_start ( GTK_BOX ( controls_box4), volume_scale, TRUE, 
									     TRUE, 0 );

	gtk_container_add ( GTK_CONTAINER ( controls_box ), play_button  );
	gtk_container_add ( GTK_CONTAINER ( controls_box ), pause_button );
	gtk_container_add ( GTK_CONTAINER ( controls_box ), stop_button );
	gtk_container_add ( GTK_CONTAINER ( controls_box ), eject_button );
	

  gtk_box_pack_start ( GTK_BOX ( controls_box2 ), menu_bar, FALSE, FALSE, 2 );

	gtk_box_pack_start ( GTK_BOX ( controls_box2 ), controls_box, 
									     FALSE, FALSE, 3);
	gtk_box_pack_start ( GTK_BOX ( controls_box2 ), separator, FALSE, FALSE, 3);
	gtk_box_pack_start ( GTK_BOX ( controls_box2 ), loop_zoom_box,
										   FALSE, FALSE, 3);
	gtk_box_pack_start ( GTK_BOX ( controls_box2 ), separator2, FALSE, FALSE, 3);
	gtk_box_pack_start ( GTK_BOX ( controls_box2 ), controls_box3, FALSE,
									     FALSE, 3 );
	gtk_box_pack_start ( GTK_BOX ( controls_box2 ), controls_box4, FALSE, 
									     FALSE, 3);


	gtk_container_add ( GTK_CONTAINER ( window ), controls_box2 );

	gtk_widget_show ( menu_bar );


	gtk_widget_show ( window );

	gtk_timeout_add ( 2000, emit_signal_slider, time_lapsed_adj);


	gtk_main ();

	return 0;
}
