/*  gmpeg- MPEG-1 player for Linux
 *
 *  Copyright (C) 2000 Jayan. S. R
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef GUI_H
#define GUI_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <smpeg/smpeg.h>
#include <SDL/SDL.h>


int loop_active;
int zoom_active;

static const char *play_data[] = {
"16 16 3 1",
"       c None",
".      c #000000000000",
"X      c #FFFFFFFFFFFF",
"                      ",
"  .                   ",
"  ..                  ",
"  ...                 ",
"  ....                ",
"  .....               ",
"  ......              ",
"  .......             ",
"  ........            ",
"  .......             ",
"  ......              ",
"  .....               ",
"  ....                ",
"  ...                 ",
"  ..                  ",
"  .                   ",
"                      "};

static const char *pause_data[] = {
"16 16 3 1",
"       c None",
".      c #000000000000",
"X      c #FFFFFFFFFFFF",
"                      ",
"                      ",
"                      ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"    ....   ....       ",
"                      ",
"                      ",
"                      "};

static const char *stop_data[] = {
"16 16 3 1",
"       c None",
".      c #000000000000",
"X      c #FFFFFFFFFFFF",
"                      ",
"                      ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"   ............       ",
"                      ",
"                      "};

static const char *eject_data[] = {
"16 16 3 1",
"       c None",
".      c #000000000000",
"X      c #FFFFFFFFFFFF",
"                      ",
"                      ",
"                      ",
"                      ",
"         .            ",
"        ...           ",
"       .....          ",
"      .......         ",
"     .........        ",
"    ...........       ",
"   .............      ",
"                      ",
"   .............      ",
"   .............      ",
"   .............      ",
"                      ",
"                      "};

static const char *full_screen_data[] = {
"16 16 3 1",
"       c None",
".      c #000000000000",
"X      c #FFFFFFFFFFFF",
"                      ",
"                      ",
" ...........          ",
" .........X.          ",
" ...........          ",
" .         .          ",
" .      ........      ",
" .      ......X.      ",
" .      ........      ",
" .      .  .   .      ",
" ...........   .      ",
"        .      .      ",
"        .      .      ",
"        ........      ",
"                      ",
"                      ",
"                      "};


GtkWidget *xpm_label_box ( GtkWidget *, gchar **, gchar *);
void ok_dialog_clicked ( GtkWidget *widget, GtkDialog *dlg );

int sdl_initialize ();

#endif
